hdu-1348 Wall(凸包)

来源:互联网 发布:python多进程event 编辑:程序博客网 时间:2024/04/30 07:02

题目链接:点击打开链接

Wall

Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
Total Submission(s): 4910    Accepted Submission(s): 1424


Problem Description
Once upon a time there was a greedy King who ordered his chief Architect to build a wall around the King's castle. The King was so greedy, that he would not listen to his Architect's proposals to build a beautiful brick wall with a perfect shape and nice tall towers. Instead, he ordered to build the wall around the whole castle using the least amount of stone and labor, but demanded that the wall should not come closer to the castle than a certain distance. If the King finds that the Architect has used more resources to build the wall than it was absolutely necessary to satisfy those requirements, then the Architect will loose his head. Moreover, he demanded Architect to introduce at once a plan of the wall listing the exact amount of resources that are needed to build the wall.
Your task is to help poor Architect to save his head, by writing a program that will find the minimum possible length of the wall that he could build around the castle to satisfy King's requirements.



The task is somewhat simplified by the fact, that the King's castle has a polygonal shape and is situated on a flat ground. The Architect has already established a Cartesian coordinate system and has precisely measured the coordinates of all castle's vertices in feet.
 

Input
The first line of the input file contains two integer numbers N and L separated by a space. N (3 <= N <= 1000) is the number of vertices in the King's castle, and L (1 <= L <= 1000) is the minimal number of feet that King allows for the wall to come close to the castle.

Next N lines describe coordinates of castle's vertices in a clockwise order. Each line contains two integer numbers Xi and Yi separated by a space (-10000 <= Xi, Yi <= 10000) that represent the coordinates of ith vertex. All vertices are different and the sides of the castle do not intersect anywhere except for vertices.
 

Output
Write to the output file the single number that represents the minimal possible length of the wall in feet that could be built around the castle to satisfy King's requirements. You must present the integer number of feet to the King, because the floating numbers are not invented yet. However, you must round the result in such a way, that it is accurate to 8 inches (1 foot is equal to 12 inches), since the King will not tolerate larger error in the estimates.

This problem contains multiple test cases!

The first line of a multiple input is an integer N, then a blank line followed by N input blocks. Each input block is in the format indicated in the problem description. There is a blank line between input blocks.

The output format consists of N output blocks. There is a blank line between output blocks.
 

Sample Input
19 100200 400300 400300 300400 300400 400500 400500 200350 200200 200
 

Sample Output
1628

题意:求n个点的凸包+一个半径为m的 圆的周长

思路:基础凸包,当模板吧

代码:

#include <iostream>#include <cstdio>#include <cstring>#include <algorithm>#include <cmath>using namespace std;#define N 1050#define PI 4*atan(1.0)#define eps 1e-8struct Node{    double x,y;} p[N],stack[N];double mulit(Node a,Node b,Node c)//向量ab与向量ac的叉乘{    return ((b.x-a.x)*(c.y-a.y)-(b.y-a.y)*(c.x-a.x));}double dist(Node s,Node e)//s点与e点的距离的平方(此处如果直接开根怕影响在传递的时候影响精度){    return (s.x-e.x)*(s.x-e.x)+(s.y-e.y)*(s.y-e.y);}int cmp(Node a,Node b)//设<p1,p2,...pm>为对其余点按以p0为中心的极角逆时针排序所得的点集(如果有多个点有相同的极角,除了距p0最远的点外全部移除){    if(mulit(p[0],a,b)>0)//向量p[0]a在向量p[0]b顺时针方向,返回1        return 1;    if(mulit(p[0],b,a)==0&&(dist(p[0],b)-dist(p[0],a)>eps))//p[0]a与p[0]b共线,而且b点距离更远        return 1;    return 0;}int Graham(int n){    int top=2;    sort(p+1,p+n,cmp);    stack[0]=p[0];    stack[1]=p[1];    stack[2]=p[2];    for(int i=3;i<n;i++)    {        while(top>=1&&mulit(stack[top-1],p[i],stack[top])>=0)            top--;        stack[++top]=p[i];    }    return top;}int main(){    int T,n,m;    scanf("%d",&T);    while(T--)    {        scanf("%d %d",&n,&m);        for(int i=0; i<n; i++)            scanf("%lf %lf",&p[i].x,&p[i].y);        int k=0;        for(int i=0; i<n; i++)        {            if(p[k].y>p[i].y||(p[k].y==p[i].y&&p[k].x>p[i].x))                k=i;        }        swap(p[0],p[k]);        int top=Graham(n);        double sum=0.0;        for(int i=1; i<=top; i++)            sum+=sqrt(dist(stack[i],stack[i-1]));        sum+=sqrt(dist(stack[0],stack[top]));        sum+=2*PI*m;        printf("%.0lf\n",sum);        if(T) printf("\n");    }    return 0;}


0 0
原创粉丝点击